#uses "FwUnitTestComponentUI.ctl"

/* Library with helping functions for UI unit tests in UNICOS */

/** Colors */
/** Invalid color */
string unUIUnitTestConfig_sInvalidColor = "unDataNotValid";

/** Disconnected color */
string unUIUnitTestConfig_sDiscColor = "unDataNoAccess";

/** Background color */
string unUIUnitTestConfig_sBackColor = "unWidget_Background";

/** Alternative color */
string unUIUnitTestConfig_sAltColor = "unWidget_AlternativeColor";


/** Symbol shapes */
/** Colorbox shape */
string unUIUnitTestConfig_sColorBox = "colorbox";

/** Display shape */
string unUIUnitTestConfig_sDisplay = "display";


/** Class to represent a ColorBox */
class ColorBox: StandardSymbol {
    /** Constructor

    @param sName         Name of the ColorBox
    */
    public ColorBox(string sName): StandardSymbol(sName, "objects/UN_INFOS/unFaceplate_Colorbox.pnl") {
        daShapes.append(StandardShape(unUIUnitTestConfig_sColorBox, "RECTANGLE"));
    }

    /** Get the rectangle contained in the colorbox

    @return StandardShape The rectangle
    */
    public StandardShape getColorBox() {
        return daShapes[1];
    }
};


/** Clas to represent a NormalDisplay */
class NormalDisplay: StandardSymbol {
    /** Constructor

    @param sName         Name of the NormalDisplay
    */
    public NormalDisplay(string sName): StandardSymbol(sName, "objects/UN_INFOS/unFaceplate_DisplayNormal.pnl") {
        daShapes.append(StandardShape(unUIUnitTestConfig_sDisplay, "TEXT_FIELD"));
    }

    /** Get the text box contained in the display

    @return StandardShape The display text
    */
    public StandardShape getDisplay() {
        return daShapes[1];
    }
};


/** Class for UNICOS shape container */
class UnShapeContainer: ShapeContainer {
    /** Define colorboxes test shapes

    @param dsNames Names of the colorboxes to create
    */
    public void addColorBoxes(dyn_string dsNames) {
        for (int i=1; i <= dynlen(dsNames); i++) {
            daShapes.append(ColorBox(dsNames[i]));
        }
    }

    /** Define normal display test shapes

    @param dsNames Names of the displays to create
    */
    public void addDisplays(dyn_string dsNames) {
        for (int i=1; i <= dynlen(dsNames); i++) {
            daShapes.append(NormalDisplay(dsNames[i]));
        }
    }
};
