#uses "fwUnitTestComponentAsserts.ctl"

#uses "unFilterDpFunctions.ctl"


const dyn_string LIST_DP = makeDynString("my-test-01", "my-test-03", "my-test-02"); //List of DP not sorted alphabatically on purpose

//-----------------------------------------
void test_unFilterDpFunctions_dpQuery_setupSuite(){
	for( int i=1; i<=dynlen(LIST_DP); i++){
		dpCreate(LIST_DP[i], "ExampleDP_Int");
		assertTrue( dpExists(LIST_DP[i]), "Could not create DP for test");
	}
}

//------------------------------------------
void test_unFilterDpFunctions_dpQuery_teardownSuite(){
	for( int i=1; i<=dynlen(LIST_DP); i++){
		dpDelete(LIST_DP[i]);
		assertFalse( dpExists(LIST_DP[i]), "Could not delete DP to clean  up test");
	}
}

//-------------------------------------------
void test_unFilterDpFunctions_dpQuery_orderedDp(){
	dyn_string dsDpNames;
	unFilterDpFunctions_dpQuery("SELECT '_online.._value' FROM 'my*'  WHERE _DPT IN (\"ExampleDP_Int\")", dsDpNames);
	dyn_string dsExpected = LIST_DP;
	for(int i=1;i<=dynlen(dsExpected); i++){ //need to have the system name to match the returns result
		dsExpected[i] = getSystemName()+dsExpected[i];
	}
	dynSort(dsExpected);
	assertEqual( dsExpected, dsDpNames, "The list of DP returned is not in the expected order");
}


//-------------------------------------------
void test_unFilterDpFunctions_dpQuery_NumFoundDp(){
	dyn_string dsDpNames;
	unFilterDpFunctions_dpQuery("SELECT '_online.._value' FROM 'my*'  WHERE _DPT IN (\"ExampleDP_Int\")", dsDpNames);
	assertEqual( dynlen(LIST_DP), dynlen(dsDpNames), "The number of found DPS not does match the expected one");
}
