#uses "fwUnitTestComponentAsserts.ctl"
#uses "unConfigGenericFunctions.ctl"

void test_unConfigGenericFunctions_getUnicosAddressReference()
{
  dyn_string dsParameters;
  string sAddressReference;

  // Output address
  dsParameters = makeDynString(DPATTR_ADDR_MODE_OUTPUT, "PREMIUM", "1", "false", "100", "FALSE");
  unConfigGenericFunctions_getUnicosAddressReference(dsParameters, sAddressReference);
  assertEqual("M.1.16.100", sAddressReference, "The output address is incorrectly parsed");

  // MODBUS polling address with 6 Parameters
  dsParameters = makeDynString(DPATTR_ADDR_MODE_INPUT_POLL, "MODBUS", "1", "false", "100", "FALSE");
  unConfigGenericFunctions_getUnicosAddressReference(dsParameters, sAddressReference);
  assertEqual("M.1.3.100", sAddressReference, "The polling address (6 parameters) is incorrectly parsed");

  // MODBUS polling address with 7 Parameters (read input register)
  dsParameters = makeDynString(DPATTR_ADDR_MODE_INPUT_POLL, "UNITY", "1", "false", "100", "FALSE", "4");
  unConfigGenericFunctions_getUnicosAddressReference(dsParameters, sAddressReference);
  assertEqual("M.1.4.100", sAddressReference, "The polling address (7 parameters) is incorrectly parsed");

  // UNICOS address (Quantum, 32 bit event)
  dsParameters = makeDynString(DPATTR_ADDR_MODE_INPUT_SPONT, "QUANTUM", "1", "true", "100", "FALSE");
  unConfigGenericFunctions_getUnicosAddressReference(dsParameters, sAddressReference);
  assertEqual("U.1.17.100", sAddressReference, "The TSPP address is incorrectly parsed");
}
